''*****************************************************************************
''
''	Platformer tutorial 101
''
''	Chapter 01-B
''  Jumping in action 
''
''	Relminator (Richard Eric M. Lope)
''	http://rel.phatcode.net
''
''
''  I'm using EASY GL2D for rendering.
'' 	So try to read these tutorials for Easy GL2D..
'' 	http://back2basic.phatcode.net/?Issue_%232:Basic_2D_Rendering_in_OpenGL_using_Easy_GL2D%3A_Part_1
'' 	http://back2basic.phatcode.net/?Issue_%232:Basic_2D_Rendering_in_OpenGL_using_Easy_GL2D%3A_Part_2
''
''*****************************************************************************

#include once "fbgfx.bi"
#include once "/gl/gl.bi" 
#include once "/gl/glu.bi"   

#include once "FBGL2D.bi"     	'' We're gonna use Hardware acceleration
#include once "FBGL2D.bas"		'' So we'll be using my LIB



''*****************************************************************************
const as integer SCREEN_WIDTH = 640
const as integer SCREEN_HEIGHT = 480


const as integer FALSE = 0
const as integer TRUE = not FALSE

'' Play with these values for kicks
const as single GRAVITY = 0.75		'' Gravity to pull object downwards
const as single JUMPHEIGHT = 15		'' Height of the jump 

const as integer FLOOR_VALUE = 400  '' Our arbitrary floor value for collision purposes


''*****************************************************************************
'' Our main sub
''*****************************************************************************
sub main()

	dim as integer Frame = 0
	 
	GL2D.ScreenInit( SCREEN_WIDTH, SCREEN_HEIGHT )   ''Set up GL screen
	GL2D.VsyncON()
	
	Dim as integer Speed = 2			'' Horizontal speed
	dim as single x = 50				'' X Position  
	dim as single y = FLOOR_VALUE		'' Y Position
	dim as single Dx = 0				'' X velocity
	dim as single Dy = -JUMPHEIGHT		'' Y velocity

	do
		
		Frame += 1						'' 
    	
    	Dx = Speed						'' Set x velocity to speed
    	Dy += GRAVITY 					'' pull the object downwards
    	
    	x += Dx							'' Move Horizontaly
		y += Dy							'' Move Vertically
		
		if( x < 0 ) then				'' Move the other way if we hit boundaries
			Speed = -Speed
		EndIf
		
		if( x > SCREEN_WIDTH ) then		'' Ditto
			Speed = -Speed
		EndIf
		
		if( y > FLOOR_VALUE ) then 		'' Bounce if we hit the floor
			y = FLOOR_VALUE
			Dy = -JUMPHEIGHT
		EndIf
		
		GL2D.ClearScreen()				'' Clear the screen
			
		GL2D.Begin2D()
			
			'' Draw the floor
			GL2D.BoxFilled( 0, FLOOR_VALUE, SCREEN_WIDTH, SCREEN_HEIGHT, GL2D_RGBA(255,255,255,255) )
			
			'' Draw the object
			GL2D.CircleFilled( x, y - 10, 10, GL2D_RGBA(0,255,255,255) )

			'' Draw the vector representation
			'' DX
			GL2D.Line2D( x, y, x + Dx * 15, y, GL2D_RGBA(0, 255, 0,255) )
			
			'' DY
			if( Dy < 0 ) then
				GL2D.Line2D( x, y, x, y + Dy * 5, GL2D_RGBA(0, 0, 255,255) )
			else
				GL2D.Line2D( x, y, x, y + Dy * 5, GL2D_RGBA(255, 0, 0,255) )
			EndIf
			
			GL2D.PrintScale(0,  10, 1, "Bounce")    
			
		GL2D.End2D()
		
		
		dim as integer FPS = GL2D.LimitFPS(60)
		
		sleep 1,1
		flip
		
	Loop until multikey(FB.SC_ESCAPE)

	GL2D.ShutDown()
	
End Sub

''*****************************************************************************
''*****************************************************************************


main()


end







